#include "wavcap.h"

TY_RINGBUFF eRINGBUFF[RECORD_RING_MAX];
int nCurrentIndex;
WCENDIAN nEndian;

//
//
//
//
//


void CALLBACK waveInProc(HWAVEIN hwi, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2)
{
	static int record_count = 0;
	LPWAVEHDR lpwhdr = (LPWAVEHDR)dwParam1;
	
	switch(uMsg){
		case WIM_DATA:
			if(lpwhdr->dwBytesRecorded != lpwhdr->dwBufferLength)
			{
				break;
			}

			if(nEndian != WCENDIAN_LITTLE)
			{
				for(int i=0; i<lpwhdr->dwBytesRecorded; i+=2)
				{
					eRINGBUFF[record_count].voice[i]   = lpwhdr->lpData[i+1];
					eRINGBUFF[record_count].voice[i+1] = lpwhdr->lpData[i];
				}
			}else{
				for(int i=0; i<lpwhdr->dwBytesRecorded; i+=2)
				{
					eRINGBUFF[record_count].voice[i]   = lpwhdr->lpData[i];
					eRINGBUFF[record_count].voice[i+1] = lpwhdr->lpData[i+1];
				}
			}

			if(waveInAddBuffer(hwi, lpwhdr, sizeof(WAVEHDR)) != MMSYSERR_NOERROR)
			{
				printf("waveInProc : waveInAddBuffer() ERROR\n");
			}
			eRINGBUFF[record_count].timestamp = timeGetTime();
			nCurrentIndex = record_count;
			record_count++;
			if(record_count >= RECORD_RING_MAX)
				record_count = 0;
			break;
	}
}


//
//
//
//
//

WavCap::WavCap(){
	m_stWFEX.nChannels		= 1;//1FmA2FXeI
	m_stWFEX.nSamplesPerSec = 16000;//TvO[g[bps]
	m_stWFEX.wBitsPerSample = 16;//ʎqrbg[bit]
	m_stWFEX.nBlockAlign	= m_stWFEX.nChannels*m_stWFEX.wBitsPerSample/8;//1Tṽf[^TCY[Byte]=`l[ch : 1 or 2]~ʎqrbg[bit]/8
	m_stWFEX.nAvgBytesPerSec = m_stWFEX.nSamplesPerSec*m_stWFEX.nBlockAlign;//1[s]̃f[^TCY[Byte/s]=1Tṽf[^TCY[Byte]~TvO[g[Hz]
	m_stWFEX.wFormatTag		= WAVE_FORMAT_PCM;

	nCurrentIndex = 0;

	timeBeginPeriod(1);
}

//
//
//
//
//

WavCap::~WavCap(){
	timeEndPeriod(1);
}

//
//
//
//
//

bool WavCap::CapStart(int buffsize, WCENDIAN endian)
{
	m_stWbuff1 = new char[buffsize];
	m_stWbuff2 = new char[buffsize];
	nEndian = endian;
	
	m_stWhdr1.lpData			= (LPSTR)m_stWbuff1;
	m_stWhdr1.dwBufferLength	= buffsize;
	m_stWhdr1.dwBytesRecorded	= 0;
	m_stWhdr1.dwFlags			= 0;
	m_stWhdr1.dwLoops			= 1;
	m_stWhdr1.lpNext			= NULL;
	m_stWhdr1.dwUser			= 0;
	m_stWhdr1.reserved			= 0;

	m_stWhdr2.lpData			= (LPSTR)m_stWbuff2;
	m_stWhdr2.dwBufferLength	= buffsize;
	m_stWhdr2.dwBytesRecorded	= 0;
	m_stWhdr2.dwFlags			= 0;
	m_stWhdr2.dwLoops			= 1;
	m_stWhdr2.lpNext			= NULL;
	m_stWhdr2.dwUser			= 0;
	m_stWhdr2.reserved			= 0;

	if(MMSYSERR_NOERROR != waveInOpen(&m_hWaveIn, WAVE_MAPPER, &m_stWFEX, (DWORD)waveInProc, 0, CALLBACK_FUNCTION))
	{
		printf("waveInOpen ERROR\n");
		return false;
	}
	if(MMSYSERR_NOERROR != waveInPrepareHeader(m_hWaveIn, &m_stWhdr1, sizeof(m_stWhdr1)))
	{
		printf("waveInPrepareHeader : m_stWhdr1 ERROR\n");
		return false;
	}
	if(MMSYSERR_NOERROR != waveInPrepareHeader(m_hWaveIn, &m_stWhdr2, sizeof(m_stWhdr2)))
	{
		printf("waveInPrepareHeader : m_stWhdr2 ERROR\n");
		return false;
	}
	if(MMSYSERR_NOERROR != waveInAddBuffer(m_hWaveIn, &m_stWhdr1, sizeof(m_stWhdr1)))
	{
		printf("waveInAddBuffer : m_stWhdr1 ERROR\n");
		return false;
	}
	if(MMSYSERR_NOERROR != waveInAddBuffer(m_hWaveIn, &m_stWhdr2, sizeof(m_stWhdr2)))
	{
		printf("waveInAddBuffer : m_stWhdr2 ERROR\n");
		return false;
	}
	if(MMSYSERR_NOERROR != waveInStart(m_hWaveIn))
	{
		printf("waveInStart ERROR\n");
		return false;
	}
	return true;
}

//
//
//
//
//

bool WavCap::CapEnd(){

	bool result = true;
	MMRESULT mResult;

	if(MMSYSERR_NOERROR != (mResult = waveInReset(m_hWaveIn)))
	{
		printf("waveInReset ERROR\n\t ErrorCode : %u\n", mResult);
		result = false;
	}

	if(MMSYSERR_NOERROR != (mResult = waveInUnprepareHeader(m_hWaveIn, &m_stWhdr1, sizeof(WAVEHDR))))
	{
		printf("waveInUnprepareHeader : m_stWhdr1 ERROR\n\t ErrorCode : %u\n", mResult);
		result = false;
	}

	if(MMSYSERR_NOERROR != (mResult = waveInUnprepareHeader(m_hWaveIn, &m_stWhdr2, sizeof(WAVEHDR))))
	{
		printf("waveInUnprepareHeader : m_stWhdr2 ERROR\n\t ErrorCode : %u\n", mResult);
		result = false;
	}

	if(MMSYSERR_NOERROR != (mResult = waveInClose(m_hWaveIn)))
	{
		printf("waveInClose ERROR\n\t ErrorCode : %u\n", mResult);
		result = false;
	}

	delete [] m_stWbuff1;
	delete [] m_stWbuff2;

	return true;
}

//
//
//
//
//

bool WavCap::makeWaveHeader(char wavHeader[44], unsigned int datSize)
{
	DWORD dwSize;
	WORD wSize;

	wavHeader[0]='R';
	wavHeader[1]='I';
	wavHeader[2]='F';
	wavHeader[3]='F';
	dwSize = 36 + datSize;//36=44-8[byte]
	memcpy_s(&wavHeader[4], 4, &dwSize, 4);
	wavHeader[8]='W';
	wavHeader[9]='A';
	wavHeader[10]='V';
	wavHeader[11]='E';	
	wavHeader[12]='f';
	wavHeader[13]='m';
	wavHeader[14]='t';
	wavHeader[15]=' ';
	dwSize = 16;//16:jAPCM
	memcpy_s(&wavHeader[16], 4, &dwSize, 4);
	wSize = 1;//1jAPCM
	memcpy_s(&wavHeader[20], 2, &wSize, 2);
	wSize = m_stWFEX.nChannels;
	memcpy_s(&wavHeader[22], 2, &wSize, 2);
	dwSize = m_stWFEX.nSamplesPerSec;
	memcpy_s(&wavHeader[24], 4, &dwSize, 4);
	dwSize = m_stWFEX.nAvgBytesPerSec;
	memcpy_s(&wavHeader[28], 4, &dwSize, 4);
	wSize = m_stWFEX.nBlockAlign;
	memcpy_s(&wavHeader[32], 2, &wSize, 2);
	wSize = m_stWFEX.wBitsPerSample;
	memcpy_s(&wavHeader[34], 2, &wSize, 2);
	wavHeader[36]='d';
	wavHeader[37]='a';
	wavHeader[38]='t';
	wavHeader[39]='a';
	dwSize = datSize;
	memcpy_s(&wavHeader[40], 4, &dwSize, 4);
	return true;
}
